//// Do the setup/initialization
dt.notes = function notes(callback) {

//No support? Go in the corner and pout.
	if (!indexedDBOk) {
		return;
	}

	var openRequest = indexedDB.open("dt_notes", 6);
	/* Method: onupgradeneeded
	 * Create or upgrade an indexed database.
	 */
	openRequest.onupgradeneeded = function (e) {
		var thisDB = e.target.result;
		console.log("running onupgradeneeded");
		if (!thisDB.objectStoreNames.contains("notes")) {
			var os = thisDB.createObjectStore("notes", {autoIncrement: true});
//I want to get by title later
			os.createIndex("title", "title", {unique: false});
//I want to get by individual tags later
			os.createIndex("tags", "tags", {unique: false, multiEntry: true});
			// I want to be able to search by complete coords and by a range on either X or Y
			os.createIndex("coords", "coords", {unique: false});
			os.createIndex("x", "x", {unique: false});
			os.createIndex("y", "y", {unique: false});
		}
		dt.db = e.target.result;
	};
//	openRequest.onsuccess(callback());
	openRequest.onsuccess = function (e) {
		console.log("running onsuccess");
		dt.db = e.target.result;
		callback();
	};
	openRequest.onerror = function (e) {
		window.alert('Error opening the database.');
		dt.db = null;
//Do something for the error
	};
};

indexedDBOk = function indexedDBOk() {
	return "indexedDB" in window;
};
dt.populateTownList = function populateTownList(node) {
	for (var i = 0; i < dt[PlayerId].towns.list.length; i++) {
		var townId = dt[PlayerId].towns.list[i];
		var thisOpt = dt.addElement2(node, 'option', ['value', 'textContent'], [townId]);
		thisOpt.textContent = dt[PlayerId].towns[townId].name;
	}

};
/* Function: addNote
 * Add a note to the notes indexedDB
 */
dt.addNote = function addNote(e) {
//	dt.notes();
//	dt_output.setAttribute('class', 'nosee');
//	document.querySelector("#dt_input").innerHTML = dt.noteEntry;
	dt.showTool("#addNoteHtml");
	$("#addNoteHtml").dialog("option", "title", "New Note");
	// Clear any existing values from the inputs
	document.querySelector("#addNoteHtml").innerHTML = '<div class="fullW" id="newNoteTbl"><input type="hidden" id="key"><table class="fullW tblBorders"><tbody><tr><td class="formlabel">Town (optional)</td></tr><tr><td><select id="noteTown" name="noteTown"><option value=null selected>Select a town</option></select></td></tr><tr><td class="formlabel">Map Coordinates (optional)</td></tr><tr><td><input type="text" placeholder="(-)xxx|(-)yyyy" id="noteCoords" class="myinp"></td></tr><tr><td class="formlabel">Title</td></tr><tr><td><input type="text" id="noteTitle" required="" class="myinp"></td></tr><tr><td class="formlabel">Body</td></tr><tr><td><textarea rows="10" cols="35" id="noteBody" required="" class="form-control"></textarea></td></tr><tr><td class="formlabel">Tags (comma separated - optional)</td></tr><tr><td><input type="text" id="noteTags" class="myinp"></td></tr></tbody></table><input type="button" onclick="dt.storeNote()" name="dt_storeNote" value="Save" id="dt_storeNote"></div>';
	var townSel = document.querySelector("#noteTown");
	dt.populateTownList(townSel);
};

dt.getAllNotes = function getAllNotes() {
//	document.querySelector("#dt_input").setAttribute('class', 'nosee');
//	document.querySelector("#dt_output").innerHTML = dt.noteSearchResTbl;
//	document.querySelector("#dt_output").setAttribute('class', 'see');
	var tbl = document.querySelector("#noteListTbl");
	dt.removeRows(tbl);
	var tbdy = tbl.querySelector("tbody");
	dt.showTool("#notesResultsHtml");
	var c = 0;
//	while(dt.db === null){
//		c=c+1;
//	}
//	var rubbish ='';
	var allNotes = [];
//	var transaction = dt.db.transaction(["notes"], "readonly");
	var objectStore = dt.db.transaction(["notes"], "readonly").objectStore("notes");
	objectStore.openCursor().onsuccess = function (event) {
//		var tbl = document.querySelector("#noteListTbl");
		var cursor = event.target.result;
		if (cursor) {
			var row = tbdy.insertRow(-1);
			var cell = row.insertCell(0);
			dt.addElement2(cell, 'input', ['type', 'id', 'value'], ['checkbox', 'cbox' + cursor.primaryKey, cursor.primaryKey]);
			cell = row.insertCell(1);
			cell.innerHTML = cursor.value['title'];
			cell.setAttribute('data-pik', cursor.primaryKey);
			cell.setAttribute('onclick', 'dt.notes.showNote(' + cursor.primaryKey + ')');
			cell.setAttribute('title', 'Click to view');
			cell = row.insertCell(2);
//			cell.innerHTML = cursor.value['town'];
			if (cursor.value['town'] !== 'null') {
				cell.innerHTML = dt[PlayerId].towns[cursor.value['town']].name;
			} else {
				cell.innerHTML = "-";
			}
			cell = row.insertCell(3);
			cell.innerHTML = cursor.value['coords'];

			allNotes.push(cursor.value);
			cursor.continue();
		}
		else {
//			alert("Got all notes: " + allNotes);
		}
	};
//	return allNotes;
};


dt.storeNote = function storeNote(e) {
	var town = $("#noteTown").val();
	var coords = document.querySelector("#noteCoords").value;
	if (coords !== null) {
		var coordArray = coords.split('|');
		var x = coordArray[0];
		var y = coordArray[1];
	} else {
		var x = "";
		var y = "";
	}
	var coords = document.querySelector("#noteCoords").value;
	var title = document.querySelector("#noteTitle").value;
	var body = document.querySelector("#noteBody").value;
	var tags = document.querySelector("#noteTags").value.split(",");
	for (i = 0; i < tags.length; i++) {
		tags[i] = tags[i].trim();
	}
	console.log("About to add " + title);
	var transaction = dt.db.transaction(["notes"], "readwrite");
	var store = transaction.objectStore("notes");
	var note = {
		town: town,
		coords: coords,
		x: x,
		y: y,
		title: title,
		body: body,
		created: new Date(),
		tags: tags
	};

//Perform the add
	var request = store.add(note);
	request.onerror = function (e) {
		alert("Sorry, couldn't add the note for some reason.");
		console.log("Error", e.target.error.name);
		console.dir(e.target);
//some type of error handler
	};

	request.onsuccess = function (e) {
		console.log("Woot! Note added");
		dt_input.innerHTML = '';
	};
};

dt.noteFind = function noteFind(e) {
//	dt.notes();
//	document.querySelector("#dt_input").innerHTML = 'Tag Search: <input type="text" id="tagSearch" placeholder="Tag"><br/><input id="dt_findNote" type="button" value="Find" name="dt_findNote" onclick="dt.getNote()">';
//	document.querySelector("#dt_input").setAttribute('class', 'see');
	dt.showTool("#noteFindHtml");
};

dt.getNote = function getNote(e) {
//	document.querySelector("#dt_output").innerHTML = dt.noteSearchResTbl;
//	document.querySelector("#dt_output").setAttribute('class', 'see');

	var tag = document.querySelector("#noteTagSearch").value;
	if (tag == "")
		return;
	dt.showTool("#notesResultsHtml");
	dt.removeRows(document.querySelector("#noteListTbl"));
	var transaction = dt.db.transaction(["notes"], "readonly");
	var store = transaction.objectStore("notes");
	var index = store.index("tags");
//Make the range depending on what type we are doing
	var range = IDBKeyRange.only(tag);
	var s = '';
	var tbl = document.querySelector("#noteListTbl tbody");
	index.openCursor(range).onsuccess = function (e) {
		var cursor = e.target.result;
		if (cursor) {
			s += "<h2>Key " + cursor.key + "</h2><p>";
			for (var field in cursor.value) {
				s += field + "=" + cursor.value[field] + "<br/>";
			}
			s += "</p>";
			dt.s = s;
			var row = tbl.insertRow(-1);
			var cell = row.insertCell(0);
			dt.addElement2(cell, 'input', ['type', 'id', 'value'], ['checkbox', 'cbox' + cursor.primaryKey, cursor.primaryKey]);
			cell = row.insertCell(1);
			cell.innerHTML = cursor.value['title'];
			cell.setAttribute('data-pik', cursor.primaryKey);
			cell.setAttribute('onclick', 'dt.showPopUp(' + cursor.primaryKey + ')');
			cell = row.insertCell(2);
			cell.innerHTML = cursor.value['town'];
			cell = row.insertCell(3);
			cell.innerHTML = cursor.value['coords'];
			cursor.continue();
		}
	};
};

dt.processSelected = function processSelected() {
	var tbl = document.querySelector("#noteListTbl");
	var checkBoxes = tbl.querySelectorAll("input[type=checkbox]");
	var marked = [];
	for (i = 0; i < checkBoxes.length; i++) {
		if (checkBoxes[i].checked === true) {
			marked.push(checkBoxes[i].value);
		}
	}
	var e = document.getElementById("noteActionType");
	var selOpt = e.options[e.selectedIndex].value;
//	var selOpt = tbl.querySelector("#actionType").selectedValue;
	switch (selOpt) {
		case 'delete':
			var confMsg = 'You are about to delete ' + marked.length + ' message(s). Are you sure?';
			if (window.confirm(confMsg)) {
				var transaction = dt.db.transaction(["notes"], "readwrite");
				var store = transaction.objectStore("notes");
				for (i = 0; i < marked.length; i++) {
					var request = store.delete(parseInt(marked[i]));
				}
			}
			break;
		case 'export':
			var outArray = [];
			for (i = 0; i < marked.length; i++) {
				var transaction = dt.db.transaction(["notes"], "readwrite");
				var store = transaction.objectStore("notes");
				var request = store.get(parseInt(marked[i]));
				request.onsuccess = function (e) {
					outArray.push(e.target.result);
				}
				request.onerror = function () {
					var rubbish = '';
				}
				var rubbish = '';
			}
			var rubbish = '';
//			var exp = {};
//			var outArray = [];
//			var objectStore = dt.db.transaction(["notes"], "readonly").objectStore("notes");
//			objectStore.openCursor().onsuccess = function (event) {
//				var cursor = event.target.result;
//				if (cursor) {
////					if (marked.indexOf(cursor.primaryKey.toString()) > -1) {
////					exp[cursor.primaryKey] = cursor.value;
//					exp[cursor.primaryKey.toString()] = cursor.value;
////					}
//					cursor.continue();
//				}
//				else {
////					var expString = JSON.stringify(exp);
////					var rubbish = '';
//			alert("Got all notes");
//				}
//			};
////				var rubbish = '';
//			for (i = 0; i < marked.length; i++) {
//				outArray.push(exp[marked[i]]);
//			}
			window.alert(JSON.stringify(outArray));
			var rubbish = '';
			break;
	}
//	dt.getNote();
};

dt.importNotes = function importNotes() {
	var importVal = prompt("Paste the exported note text here.");
	importVal = importVal.trim();
	var importObjs = JSON.parse(importVal);
//	var keys = Object.keys(importObjs);
	var transaction = dt.db.transaction(["notes"], "readwrite");
	var store = transaction.objectStore("notes");
	var req;
	if (store) {
//		var req;
//		var customer = {};
		req = store.add(importObjs);
//		for (loop = 0; loop < keys.length; loop++) {
//		var newNote = importObjs[keys[loop]];
//		req = store.add(newNote);
		req.onsuccess = function (ev) {
			window.alert('Notes imported.');
		};
		req.onerror = function (ev) {
			window.alert('Note import failed.');
		};
//		}
	}
};
/* Function: restoreNotes
 * Restore notes from a backup file. 
 */
dt.restoreNotes = function restoreNotes() {
	dt.showTool("#noteBackupRestoreHtml");
//	dt_input.innerHTML = '<p>Select the file holding your backup</p><input type="file" onchange="loadFile()">';
//	document.querySelector("#dt_input").className = 'see';
//	document.querySelector("#dt_output").className = 'nosee';
};
function loadFile() {
	var file = document.querySelector('input[type=file]').files[0];
	var reader = new FileReader();
	reader.onload = function (e) {
		var importVal = reader.result;
		importVal = importVal.trim();
		var importObjs = JSON.parse(importVal);
		var keys = Object.keys(importObjs);
		for (value in keys) {
			var thisNote = importObjs[value];
			var transaction = dt.db.transaction(["notes"], "readwrite");
			var store = transaction.objectStore("notes");
			var req;
			req = store.put(thisNote.value, thisNote.key);
			req.onerror = function (ev) {
				window.alert('Note import failed.');
			};
		}
	};
	reader.readAsText(file);
//	importVal = importVal.trim();
//	var importObjs = JSON.parse(importVal);
//	var keys = Object.keys(importObjs);
//	for (value in keys) {
//		var thisNote = importObjs[value];
//		var transaction = dt.db.transaction(["notes"], "readwrite");
//		var store = transaction.objectStore("notes");
//		var req;
//		req = store.add(thisNote.value);
//		req.onerror = function (ev) {
//			window.alert('Note import failed.');
//		};
//	}
}
;

dt.delNote = function delNote(key) {
	var confMsg = 'You are about to delete this note. Are you sure?';
	if (window.confirm(confMsg)) {
		var transaction = dt.db.transaction(["notes"], "readwrite");
		var store = transaction.objectStore("notes");
		var request = store.delete(key);
	}
	dt.showPopUp(key);
	dt.getNote();

};

dt.expNote = function expNote(existkey) {
	var transaction = dt.db.transaction(["notes"], "readonly");
	var store = transaction.objectStore("notes");
	var request = store.get(existkey);
	request.onsuccess = function () {
		alert(JSON.stringify(request.result));
//		dt_output.innerHTML = dt.noteEntry;
//		document.querySelector('#key').value = existkey;
//		dt.populateTownList(document.querySelector("#noteTown"));
//		if (request.result["town"] !== 'null') {
//			document.querySelector('#noteTown option[value="' + request.result["town"] + '"]').selected = true;
//		}
//		if (request.result["coords"] !== '') {
//			document.querySelector('#noteCoords').value = request.result['coords'];
//		}
//		if (request.result["title"] !== '') {
//			document.querySelector('#noteTitle').value = request.result['title'];
//		}
//		if (request.result["body"] !== '') {
//			document.querySelector('#noteBody').textContent = request.result['body'];
//		}
//		if (request.result["tags"].join(',') !== '') {
//			document.querySelector('#noteTags').value = request.result['tags'].join(',');
//		}
//		document.querySelector('#dt_storeNote').setAttribute('onclick', 'dt.updateNote(' + existkey + ')');
//
	};
	request.onerror = function () {
		window.alert('problem getting note to edit');
	};
};


dt.editNote = function editNote(existkey) {
	var transaction = dt.db.transaction(["notes"], "readwrite");
	var store = transaction.objectStore("notes");
	var request = store.get(existkey);
	request.onsuccess = function () {
		dt.showTool("#addNoteHtml");
		$("#addNoteHtml").dialog("option", "title", "Edit Note");
//		dt_output.innerHTML = dt.noteEntry;
		document.querySelector('#key').value = existkey;
		dt.populateTownList(document.querySelector("#noteTown"));
		if (request.result["town"] !== 'null') {
			document.querySelector('#noteTown option[value="' + request.result["town"] + '"]').selected = true;
		}
		if (request.result["coords"] !== '') {
			document.querySelector('#noteCoords').value = request.result['coords'];
		}
		if (request.result["title"] !== '') {
			document.querySelector('#noteTitle').value = request.result['title'];
		}
		if (request.result["body"] !== '') {
			document.querySelector('#noteBody').textContent = request.result['body'];
		}
		if (request.result["tags"].join(',') !== '') {
			document.querySelector('#noteTags').value = request.result['tags'].join(',');
		}
		document.querySelector('#dt_storeNote').setAttribute('onclick', 'dt.updateNote(' + existkey + ')');

	};
	request.onerror = function () {
		window.alert('problem getting note to edit');
	};
};

dt.updateNote = function updateNote(key) {
	var town = $("#noteTown").val();
	var coords = document.querySelector("#noteCoords").value;
	if (coords !== null) {
		var coordArray = coords.split('|');
		var x = coordArray[0];
		var y = coordArray[1];
	} else {
		var x = "";
		var y = "";
	}
	var title = document.querySelector("#noteTitle").value;
	var body = document.querySelector("#noteBody").value;
	var tags = document.querySelector("#noteTags").value.split(",");
	for (i = 0; i < tags.length; i++) {
		tags[i] = tags[i].trim();
	}
	console.log("About to update " + title);
	var transaction = dt.db.transaction(["notes"], "readwrite");
	var store = transaction.objectStore("notes");
	var note = {
		town: town,
		coords: coords,
		x: x,
		y: y,
		title: title,
		body: body,
		created: new Date(),
		tags: tags
	};

//Perform the update
	var request = store.put(note, key);
	request.onerror = function (e) {
		alert("Sorry, couldn't update the note for some reason.");
		console.log("Error", e.target.error.name);
		console.dir(e.target);
//some type of error handler
	};

	request.onsuccess = function (e) {
		console.log("Woot! Note updated");
		dt.showPopUp(key);
		dt_output.innerHTML = '';
//		dt.getNote();
	};
};
dt.notes.showNote = function (noteId) {
	var transaction = dt.db.transaction(["notes"], "readonly");
	var store = transaction.objectStore("notes");
	var request = store.get(noteId);
	request.onsuccess = function (e) {
		dt.showTool("#dt_noteDisplay");
		var displayDiv = document.querySelector("#dt_noteDisplay");
		displayDiv.innerHTML = '<h4>' + request.result["title"] + '</h4><table border="1" style="margin-bottom: 10px; margin-right:10px"><tr><td class="formlabel">Town</td><td>' + request.result["town"] + '</td></tr><tr><td class="formlabel">Map Coordinates</td><td>' + request.result["coords"] + '</td></tr><tr><td class="formlabel">Body</td><td>' + request.result["body"] + '</td></tr><tr><td class="formlabel">Tags</td><td>' + request.result["tags"] + '</td></tr></table><input type="button" onclick="dt.editNote(' + noteId + ')" name="dt_editNote" value="Edit"><input type="button" onclick="dt.delNote(' + noteId + ')" name="dt_delNote" value="Del"><input type="button" value="Exp" name="dt_expNote" onclick="dt.expNote(' + noteId + ')">';
		var rubbish = '';

	};
	request.onerror = function (e) {
		window.alert('Couldnt display the note.');
	};
};

dt.showPopUp = function showPopUp(pid) {
	var transaction = dt.db.transaction(["notes"], "readonly");
	var store = transaction.objectStore("notes");
	var request = store.get(pid);
	request.onsuccess = function (e) {
		var newDiv = document.querySelector("#dt_noteDisplay");
		if (request.result) {
			var tbl = '<table border="1" style="margin-bottom: 10px; margin-right:10px">\n\
<tr><td class="formlabel">Town</td><td>' + request.result["town"] + '</td></tr>\n\
<tr><td class="formlabel">Map Coordinates</td><td>' + request.result["coords"] + '</td></tr>\n\
<tr><td class="formlabel">Body</td><td>' + request.result["body"] + '</td></tr>\n\
<tr><td class="formlabel">Tags</td><td>' + request.result["tags"] + '</td></tr>\n\
</table><input type="button" onclick="dt.editNote(' + pid + ')" name="dt_editNote" value="Edit"><input type="button" onclick="dt.delNote(' + pid + ')" name="dt_delNote" value="Del"><input type="button" value="Exp" name="dt_expNote" onclick="dt.expNote(' + pid + ')">';
			newDiv.innerHTML = '<h4>' + request.result["title"] + '</h4>' + tbl;
		} else {
			document.querySelector("#dt_noteDisplay").innerHTML = 'Note Deleted.';
		}
		$(document).ready(function () {
			dt.showTool("#dt_noteDisplay");
//			$("#dt_noteDisplay").dialog();
//			document.querySelector('#ui-dialog-title-dt_noteDisplay').textContent = "durcNote";
			var rubbish = '';
		});
	};
	request.onerror = function (e) {
		window.alert('Couldnt display the note.');
	};
};

dt.hidePopUp = function hidePopUp() {
	document.querySelector("#dt_noteDisplay").innerHTML = '';
	document.querySelector("#dt_noteDisplay").setAttribute('class', 'nosee');
};

dt.backupNotes = function backupNotes() {

//	$("#exportButton").click(function(e) {
	//block click before ready
	if (!dt.db)
		return;
	db = dt.db;
//    e.preventDefault();
	var link = $("#exportLink");

	//Ok, so we begin by creating the root object:
	var data = {};
//    var promises = [];
	for (var i = 0; i < db.objectStoreNames.length; i++) {
		//thanks to http://msdn.microsoft.com/en-us/magazine/gg723713.aspx
//        promises.push(

//            $.Deferred(function(defer) {

		var objectstore = db.objectStoreNames[i];
		console.log(objectstore);

		var transaction = db.transaction([objectstore], "readonly");
		var content = [];

//                transaction.oncomplete = function(event) {
//                    console.log("trans oncomplete for "+objectstore + " with "+content.length+" items");
//                    defer.resolve({name:objectstore,data:content});
//                };

		transaction.onerror = function (event) {
			// Don't forget to handle errors!
			console.dir(event);
		};

		var handleResult = function (event) {
			var cursor = event.target.result;
			if (cursor) {
				content.push({key: cursor.key, value: cursor.value});
				cursor.continue();
			}
			var dataToStore = content;
			//serialize it
			dt.serializedData = JSON.stringify(dataToStore);
			dt.showTool("#noteBackupHtml");

		};

		var objectStore = transaction.objectStore(objectstore);
		objectStore.openCursor().onsuccess = handleResult;

//            }).promise()

//        );
	}

//    $.when.apply(null, promises).then(function(result) {
	//arguments is an array of structs where name=objectstorename and data=array of crap
	//make a copy cuz I just don't like calling it argument
//	var dataToStore = content;
//	//serialize it
//	dt.serializedData = JSON.stringify(dataToStore);
//	dt.showTool("#noteBackupHtml");
//	dt_output.innerHTML = '<a href="javascript:onDownload(dt.serializedData);">Download</a>';
//	dt_output.setClass('see');
//	dt_output.setClass="see";
//	var link = document.createElement('a');
//	link.innerHTML = 'download';

//	link.addEventListener('click', function (ev) {
//		link.href = 'data:Application/octet-stream,'+encodeURIComponent(serializedData);
//		link.download = "durcNotes.txt";
//	}, false);
//
//	dt_output.appendChild(link);

//	alert(serializedData);


//        //The Christian Cantrell solution
//        //document.location = 'data:Application/octet-stream,' + encodeURIComponent(serializedData);
//        link.attr("href",'data:Application/octet-stream,'+encodeURIComponent(serializedData));
//        //link.trigger("click");
//        fakeClick(link[0]);
////    });
//
////});
};

function onDownload(dataToDownload) {
	document.location = 'data:Application/octet-stream,' +
			  encodeURIComponent(dataToDownload);
}

dt.noteDisplay = '<div class="nosee" id="displayNoteTbl" width="100%"><table border="1"  width="100%"><colgroup><tr><col width="50%"><col width="50%"></tr></colgroup><tr><td class="formlabel">Town</td><td class="formlabel">Map Coordinates</td></tr><tr><td></td><td></td></tr><tr><td class="formlabel" colspan="2">Title</td></tr><tr><td colspan="2"></td></tr><tr><td colspan="2"></td></tr><tr><td class="formlabel" colspan="2">Tags</td></tr><tr><td colspan="2"></td></tr></table><input type="button" value="Edit" name="dt_editNote" onclick="dt.editNote(id)"><input type="button" value="Del" name="dt_delNote" onclick="dt.delNote(id)"><input type="button" value="Exp" name="dt_expNote" onclick="dt.expNote(id)"></div>';
// The floating div
dt.floating1 = '<div class="ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix"><span id="ui-dialog-title-3" class="ui-dialog-title">durcTools2 Notes</span><a class="ui-dialog-titlebar-close ui-corner-all" href="#" role="button"></a></div><div id="dt_window1_content" class="dt_notes oddeven ui-dialog-content ui-widget-content" style="overflow-x: hidden; overflow-y: scroll; white-space: normal; word-wrap: break-word; height: 330px; width: auto; min-height: 0px;" scrolltop="0" scrollleft="0"></div><div class="ui-resizable-handle ui-resizable-n"></div><div class="ui-resizable-handle ui-resizable-e"></div><div class="ui-resizable-handle ui-resizable-s"></div><div class="ui-resizable-handle ui-resizable-w"></div><div class="ui-resizable-handle ui-resizable-se ui-icon ui-icon-gripsmall-diagonal-se ui-icon-grip-diagonal-se" style="z-index: 1001;"></div><div class="ui-resizable-handle ui-resizable-sw" style="z-index: 1002;"></div><div class="ui-resizable-handle ui-resizable-ne" style="z-index: 1003;"></div><div class="ui-resizable-handle ui-resizable-nw" style="z-index: 1004;"></div>';

// The table to display the summary of notes
dt.noteTbl = '<div id="noteTable"><div id="noteListTblHdr"><table border="1"><colgroup><col width="165px"><col width="90px"><col width="70px"></colgroup><thead><tr><th>Title</th><th>Updated</th><th>&nbsp;</th></tr></thead><tbody></tbody></table></div><div id="noteListtbl"><table width="100%" border="1" id="noteListTbl"><colgroup><col width="165px"><col width="90px"><col width="70px"></colgroup><tbody id="noteListBody"></tbody></table></div></div>';
// The form for adding a new note
dt.noteEntry = '<div id="newNoteTbl" width="100%"><input id="key" type="hidden"><table border="1"  width="100%"><tr><td class="formlabel">Town (optional)</td></tr><tr><td><select name="noteTown" id="noteTown"><option value=null selected>Select a town</option></select></td></tr><tr><td class="formlabel">Map Coordinates (optional)</td></tr><tr><td><input class="myinp" type="text" class="form-control" id="noteCoords" placeholder="xxx|(-)yyy"></td></tr><tr><td class="formlabel">Title</td></tr><tr><td><input class="myinp" type="text" class="form-control" required="" id="noteTitle"></td></tr><tr><td class="formlabel">Body</td></tr><tr><td><textarea class="form-control" required="" id="noteBody" cols="35" rows="10"></textarea></td></tr><tr><td class="formlabel">Tags (comma separated - optional)</td></tr><tr><td><input class="myinp" type="text" class="form-control" id="noteTags"></td></tr></table><input id="dt_storeNote" type="button" value="Save" name="dt_storeNote" onclick="dt.storeNote()"></div>';

dt.noteSearchResTbl = '<div id="resultsTable"><h4>Note Search Results Table</h4><div><table border="1" id="noteListTbl"><colgroup><col width="35px"><col width="165px"><col width="90px"><col width="70px"></colgroup><thead><tr><th>Sel</th><th>Title</th><th>Town</th><th>Coords</th></tr></thead><tbody></tbody></table></div><p>With selected: <select name="actionType" id="actionType"><option value="delete">Delete</option></select>\t<input type="button" value="Go" name="dt_processChecked" onclick="dt.processSelected()"></div>';
