/*File: mutations.js
 * Setup and run a mutation observer that then calls the relevant function.
 * 
 */
// select the target node
// In this case we will monitor the main content div as it is present on every page we want to monitor.
var target = document.getElementById('MainContentDiv');
// create an observer instance
var observer = new MutationObserver(function (mutations) {
	var mutlist = '';
	var nlist = '';
	dt.oldH = '';
	var lastMut = mutations.pop();
	mutations = [];
	try {
		if (lastMut.type == 'childList' && window.location != 'https://elgea.illyriad.co.uk/#/World/Herald') {
			var h = document.querySelector('#MainContentDiv h1').textContent;
			if (h != dt.oldH) {
				var msg = "Page changed to " + h + ".";
				dt.logEntry(msg);
				dt.oldH = h;
			}
		}
	}
	catch (e) {
//		window.alert(dt.oldH);
	}

	dt.mutations.callRoutine();
});

// configuration of the observer:
var config = {childList: true, subtree: true};

// pass in the target node, as well as the observer options
observer.observe(target, config);

// later, you can stop observing
//observer.disconnect();

dt.mutations = {
	setup: function () {
		// select the target node
// In this case we will monitor the main content div as it is present on every page we want to monitor.
		var target = document.getElementById('MainContentDiv');
// create an observer instance
		var observer = new MutationObserver(function (mutations) {
			var mutlist = '';
			var nlist = '';
			dt.oldH = '';
			var lastMut = mutations.pop();
			mutations = [];
			if (lastMut.type == 'childList' && window.location != 'https://elgea.illyriad.co.uk/#/World/Herald') {
				try {
					var h = document.querySelector('#MainContentDiv h1').textContent;
					if (h != dt.oldH) {
						var msg = "Page changed to " + h + ".";
						dt.logEntry(msg);
						dt.oldH = h;
					}
				}
				catch (e) {
//					window.alert(dt.oldH);
				}
			}
			dt.mutations.callRoutine();
		});

// configuration of the observer:
//var config = {childList: true, subtree: true};
		var config = {childList: true};

// pass in the target node, as well as the observer options
		observer.observe(target, config);
	},
	callRoutine: function () {
		switch (dt.oldH) {
			case "Mail":
				dt.mailsearch(dt.scanMail);
				break;
			case "City Map":
				dt.buildings.bldgScan();
				break;
			case "Inventory of Resources":
				dt.invent.getTownInventory();
				break;
			case "Trade Hub Inventory":
				dt.invent.getHubInv();
				break;
			case "Trade Markets":
				dt.invent.tradeMarkets();
				break;
			case "Item Production":
				dt.production.getProdSchedule();
				break;
			case "Military Movements":
				dt.military.scanMilMov();
				break;
			case "Military Sieges":
			dt.military.scanSieges();
			break;
			case "Military Armies":
				dt.military.scanMilArmy();
				break;
			case "Military Commanders":
				dt.military.scanMilCommander();
				break;
			case "Military Overview":
				dt.military.scanMilOverview();
				break;
			case "Military Mission":
				dt.military.addOccupyMax();
				break;
			case "World Map":
				if (dt[PlayerId].settings.factionScanState === true) {
					dt.scanFactionTroops();
				}
				break;
			case "Sovereignty Held by this Town":
				dt.sov.getSovDetails();
				break;
			case "Blacksmith Production":
				dt.production.getBldgProd();
				break;
			case "Blacksmith Production":
			case "Book Binder Production":
			case "Brewery Production":
			case "Common Ground Production":
			case "Forge Production":
			case "Paddock Production":
			case "Saddlemaker Production":
			case "Spearmaker Production":
			case "Tannery Peoduction":
				dt.production.getBldgProd();
				break;
			default:
				break;
		}
	}
};
