/* File: production.js
 * Functions to manage production queues and alerts
 */
dt.production = {
		setup: function () {
var topNav = document.querySelector('body');
dt.prodAlarm = dt.addElement('',topNav,'img',['src','alt','id','class'],[dt.server + '/images/prodAlert.gif','Prod queue ended','dt_prodAlarm','nosee']);
	this.updateQueues();

	},

	prodCheckFreq: function () {
		var chkfreq = document.querySelector("#prodCheckFreq");
		dt[PlayerId].settings.chkFreq = parseInt(chkfreq.options[chkfreq.selectedIndex].value);
		window.clearInterval(dt.prodCheckTimer);
		dt.prodCheckTimer = window.setInterval(dt.production.updateQueues, dt[PlayerId].settings.chkFreq);
		var key = PlayerId + ':settings';
		locStorage.setItem(key, JSON.stringify(dt[PlayerId].settings));
	},
	monitorSetup: function () {
//		document.getElementById('dt_input').innerHTML = dt.production.bldgsToMonitorTbl;
//		document.getElementById('dt_input').setAttribute('class', 'see');
		var twnBldgs = Object.keys(dt[PlayerId].towns[CurrentTown].prod);
//		var bldgsToMon = document.getElementById('bldgsToMon');
		var bldgsToMon = document.querySelector('#bldgsToMon tbody');
		for (var i = 0; i < twnBldgs.length; i++) {
			var bldgId = twnBldgs[i];
			var row = bldgsToMon.insertRow(-1);
			var cell = row.insertCell(0);
			// <input type="checkbox" name="filters[]" value="1" />Arctic<br />
			dt.addElement2(cell, 'input', ['type', 'name', 'value', 'onchange'], ['checkbox', 'filters[]', bldgId, 'dt.production.changeEventHandler(event)']);
			var cBox = cell.querySelector('input');
			cBox.checked = dt[PlayerId].towns[CurrentTown].prod[bldgId].alertStatus;
			cell = row.insertCell(1);
			cell.textContent = dt[PlayerId].towns[CurrentTown].prod[bldgId].Building;
		}
		dt.showTool("#prodMonSetupHtml");
	},
	monitorSetupDone: function () {
		document.getElementById("dt_input").innerHTML = "";
	},
		changeEventHandler: function (event) {
		var bldg = event.target.value;
		if (dt[PlayerId].towns[CurrentTown].prod[bldg].alertStatus === false) {
			dt[PlayerId].towns[CurrentTown].prod[bldg].alertStatus = true;
		} else {
			dt[PlayerId].towns[CurrentTown].prod[bldg].alertStatus = false;
		}
		var key = CurrentTown + ':prod';
		locStorage.setItem(key, JSON.stringify(dt[PlayerId].towns[CurrentTown].prod));

		var rubbish = '';
	},
	showIdle: function () {
		// Turn of the visual alert
		var alarmImg = document.getElementById('dt_prodAlarm');
		alarmImg.setAttribute('class', 'nosee');
		// Get the tbody of the table for the idle queues
		var tb = document.querySelector('#idleQueuesTbl tbody');
		// Get the list of towns
		var twns = dt[PlayerId].towns.list;
		// Step through the towns
		for (var t = 0; t < twns.length; t++) {
			// Get the list of monitored buildings for this town
			var thisTownProdBldgs = Object.keys(dt[PlayerId].towns[twns[t]].prod);
			// Loop through each of these buildings
			for (var i = 0; i < thisTownProdBldgs.length; i++) {
				var bldgId = thisTownProdBldgs[i];
				// Check if this building queue is empty and is set to be monitored.
				if (dt[PlayerId].towns[twns[t]].prod[bldgId].endsAt === "Empty" && dt[PlayerId].towns[twns[t]].prod[bldgId].alertStatus === true) {
					// Yes it is so add it to the table
					var row = tb.insertRow(-1);
					var cell = row.insertCell(0);
					cell.textContent = dt[PlayerId].towns[twns[t]].name;
					cell = row.insertCell(1);
					cell.textContent = dt[PlayerId].towns[twns[t]].prod[bldgId].Building;
				}
			}
		}
		dt.showTool("#showIdleBldgsHtml");
	},

};

